class Eleve:
    def __init__(self):
        self.student_id = -1
        self.email = "*"
        self.prenom = "*"
        self.nom = "*"
        self.module = []

def load_data(path):
    with open(path) as f:
        data = f.readlines()

    return data

def extract_names(email):
    #Return ["prenom","nom"]
    data = email
    data = data.split("@")
    data = data[0]
    res = data.split(".")
    return res

def load_data_to_struct():
    parse_data = []

    for i in range(len(data)):
        data[i] = data[i].split(" ")
        eleve = Eleve()
        eleve.student_id = data[i][0]
        eleve.email = data[i][1]
        eleve.prenom = extract_names(data[i][1])[0]
        eleve.nom = extract_names(data[i][1])[1]
        for element in data[i]: #load module_info
            if len(element) == 5:
                eleve.module.append(element)
            elif len(element) == 6:
                eleve.module.append(element.replace("\n",""))



        parse_data.append(eleve)

    return parse_data

def del_singleton(alist):
    save = []
    new_list = []
    for i in range(len(alist)):
        if alist[i] not in save:
            save.append(alist[i])
        else:
            new_list.append(alist[i])

    return new_list

def display(student_id, email):
    for data in parse_data:
        if data.student_id == student_id:
            if email:
                print(data.prenom, data.nom, data.module, "     ", data.email)
            else:
                print(data.prenom, data.nom, data.module)

def search(*nom_list, email = False):

    personnes_retenus = []

    for nom in nom_list:
        for data in parse_data:
            #Search pour les modules
            for module in data.module:
                nom = nom.upper()
                if module == nom:
                    personnes_retenus.append(data.student_id)

            #Search pour les noms
            nom = nom.lower()
            if data.prenom == nom or data.nom == nom:
                personnes_retenus.append(data.student_id)

    if len(nom_list) > 1:
        personnes_retenus = del_singleton(personnes_retenus)

    print("")
    for personnes_id in personnes_retenus:
        display(personnes_id, email)

    print("\nNombre de personnes: ", len(personnes_retenus))


data = load_data("data.txt")
parse_data = load_data_to_struct()
